/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.92 by jmc, Wed Sep 5 01:46:37 2007 UTC revision 1.114 by jmc, Wed Apr 2 23:41:22 2008 UTC
# Line 15  usage() Line 15  usage()
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
26      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 64  usage() Line 67  usage()
67  build_mpack()  build_mpack()
68  {  {
69      printf "building the mpack utility...  "      printf "building the mpack utility...  "
70      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
71        if test ! -x $MPACK ; then
72          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
73              echo              echo
74              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 73  build_mpack() Line 77  build_mpack()
77              echo              echo
78              HAVE_MPACK=f              HAVE_MPACK=f
79          fi          fi
         printf "building mpack...  "  
80          if test "x$CC" = x ; then          if test "x$CC" = x ; then
81              export CC=cc              export CC=cc
82          fi          fi
83            printf "building mpack (using CC=$CC)...  "
84          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
85          RETVAL=$?          RETVAL=$?
86          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 87  build_mpack() Line 91  build_mpack()
91          else          else
92              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
93              HAVE_MPACK=t              HAVE_MPACK=t
94                echo "done"
95          fi          fi
96      else      else
97          HAVE_MPACK=t          HAVE_MPACK=t
98            echo "already exist"
99      fi      fi
     echo "OK"  
100  }  }
101    
102  testoutput_for_prop()  testoutput_var()
103  {  {
104      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
105      #      #
106      #  compares files $dir/$subdir/$OUTPUTFILE and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
107      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
108        #  using search strings s1 and text label
109    
110      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
111          echo testoutput_for_prop: grep "$2" $1/$4/$OUTPUTFILE 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
112      fi      fi
113      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
114          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
115          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
116          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
117              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
118                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
119              fi              fi
120              return 99              return 99
121          fi          fi
122      else      else
123          echo testoutput_for_prop: $OUTPUTFILE from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
124          return 99          return 99
125      fi      fi
126      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
127          echo testoutput_for_prop: grep "$2" $1/results/output.$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
128      fi      fi
129      grep "$2" $1/results/output.$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
130      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
131      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
132          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
133              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
134          fi          fi
# Line 136  testoutput_for_prop() Line 142  testoutput_for_prop()
142      fi      fi
143      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat tmp1.txt | grep -i nan | wc -l`
144      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
145          echo testoutput_for_prop: $OUTPUTFILE contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
146          return 99          return 99
147      fi      fi
148      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat tmp1.txt | grep -i inf | wc -l`
149      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
150          echo testoutput_for_prop: $OUTPUTFILE contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
151          return 99          return 99
152      fi      fi
153      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
154          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
155      fi      fi
156      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
157      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
158          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
159      fi      fi
160      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
161          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 160  testoutput_for_prop() Line 166  testoutput_for_prop()
166      digits_of_similarity=`./tr_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
167      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
168          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
169              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
170          fi          fi
171          digits_of_similarity=99          digits_of_similarity=99
172      else      else
173          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
174              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
175          fi          fi
176      fi      fi
177      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 173  testoutput_for_prop() Line 179  testoutput_for_prop()
179      return $digits_of_similarity      return $digits_of_similarity
180  }  }
181    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tr_cmpnum < t5.txt`  
     digits_6=`./tr_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
182  check_for_add_mon_output()  check_for_add_mon_output()
183  {  {
184      # Check for additional types of monitor output      # Check for additional types of monitor output
# Line 229  check_for_add_mon_output() Line 204  check_for_add_mon_output()
204      done      done
205  }  }
206    
207  testoutput()  testoutput_run()
208  {  {
209      # testoutput directory subdir extension      # testoutput_run directory subdir reference_output
210      #      #
211      #  test output in "directory"      #  test output from 1 run in "directory"
212      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
213          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
214              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
215          fi          #  others : number of matching digits to be printed in summary.txt
216          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
217          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
218              echo testoutput: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
219          fi          sVar=`echo $listChk | awk '{print $1}'`
220          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
221          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
222          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
223          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
224          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          for ii in 1 2 3 4 5 6 7 8 9 ; do
225          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`
226          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
227          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi
228          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?          done
229          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`
230          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?          if test $tst != 1 ; then
231          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
232          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
233          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?            echo "==> WARNING: in checked list:" $listVar 1>&2
234          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?          #- put it back once:
235          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
236            fi
237          #  This is for PTRACERS          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
238          for ii in $PTRACERS_NUM ; do          echo "listVar='$listVar'" > $CDIR"/summary.txt"
239              eval `echo "p0"$ii"_min=99"`          allargs=""
240              eval `echo "p0"$ii"_max=99"`          for xx in $listVar
241              eval `echo "p0"$ii"_mean=99"`          do
242              eval `echo "p0"$ii"_sd=99"`            case $xx in
243              tst=`eval 'echo "$HAVE_PTR0'$ii'"'`             'PS')  if [ $debug -gt 0 ]
244              #echo 'tst = '$tst                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
245              if test "x$tst" = xt ; then                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
246                  a="trcstat_ptracer0"                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
247                  testoutput_for_prop $1 "$a"$ii"_min"  "p0"$ii"_min"  $2 $3            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
248                  RETVAL=$? ; eval `echo "p0"$ii"_min="$RETVAL`            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
249                  testoutput_for_prop $1 "$a"$ii"_max"  "p0"$ii"_max"  $2 $3             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
250                  RETVAL=$? ; eval `echo "p0"$ii"_max="$RETVAL`             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
251                  testoutput_for_prop $1 "$a"$ii"_mean" "p0"$ii"_mean" $2 $3             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
252                  RETVAL=$? ; eval `echo "p0"$ii"_mean="$RETVAL`             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
253                  testoutput_for_prop $1 "$a"$ii"_sd"   "p0"$ii"_sd"   $2 $3             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
254                  RETVAL=$? ; eval `echo "p0"$ii"_sd="$RETVAL`             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
255              fi             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
256          done             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
257               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
258          allargs="$cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd"             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
259          allargs="$allargs $umin $umax $umean $usd $vmin $vmax $vmean $vsd"             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
260          allargs="$allargs $p01_min $p01_max $p01_mean $p01_sd"             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
261          allargs="$allargs $p02_min $p02_max $p02_mean $p02_sd"             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
262          allargs="$allargs $p03_min $p03_max $p03_mean $p03_sd"             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
263          allargs="$allargs $p04_min $p04_max $p04_mean $p04_sd"             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
264          allargs="$allargs $p05_min $p05_max $p05_mean $p05_sd"             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
265            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266          eval "dashnum $allargs"             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
267            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
268      else             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
269          testoutput_ad $1 $2 "precision_grdchk_result"          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
270      fi             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
271            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
272               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
273             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
274             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
275             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
276             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
277             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
278             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
279             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
280             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
281             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
282             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
283             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
284             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
285            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
286            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
287            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
288            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
289            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
290            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
291                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
292              esac
293              if test $xx = $sVar
294              then allargs="$allargs > $yy <"
295              else allargs="$allargs $yy"
296              fi
297            done
298    
299            nbVar=`echo $listVar | awk '{print NF}'`
300            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
301            #-- fill line (up to standard length) with dot:
302              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
303              echo $allargs $adNul
304            else
305              echo $allargs
306            fi
307    # <-- same processing for adjoint & forward test
308  }  }
309    
310  genmakemodel()  genmakemodel()
# Line 320  genmakemodel() Line 332  genmakemodel()
332              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
333                  command="$command -ieee"                  command="$command -ieee"
334              fi              fi
335                if test "x$GSL" = xt ; then
336                    command="$command -gsl"
337                fi
338              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
339                  command="$command -mpi"                  command="$command -mpi"
340              fi              fi
# Line 392  run_clean() Line 407  run_clean()
407              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
408              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
409              rm -rf mnc_test_*              rm -rf mnc_test_*
410                rm -f *_MIT_CE_000.opt0000 costfunction*0000
411              echo successful 1>&2              echo successful 1>&2
412              exit 0              exit 0
413          )          )
# Line 462  symlink_mpifiles() Line 478  symlink_mpifiles()
478      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
479            
480      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
481      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
482    
483      #  Is this an MPI run?      #  Is this an MPI run?
484      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 520  linkdata() Line 536  linkdata()
536                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
537                  fi                  fi
538              fi              fi
539                prevDir='NONE'
540              for ldir in $* ; do              for ldir in $* ; do
541                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
542                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
543                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
544                      for i in $files ; do                      for i in $files ; do
# Line 537  linkdata() Line 554  linkdata()
554                      fi                      fi
555                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
556                  fi                  fi
557                    prevDir=$ldir
558              done              done
559          )          )
560      fi      fi
# Line 553  runmodel() Line 571  runmodel()
571          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
572          # make output.txt          # make output.txt
573          echo          echo
574            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
575                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
576                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; rm -f run.log ; fi
577            fi
578          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
579              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
580              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
# Line 564  runmodel() Line 586  runmodel()
586                  RETVAL=8                  RETVAL=8
587                  ENDVAL=-1                  ENDVAL=-1
588          else          else
589              if test $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
590                  # output do not exist or is older than executable:
591                  rm -f run.log ; touch run.log                  rm -f run.log ; touch run.log
592                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
593                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> run.log 2>&1
# Line 606  createcodelet() Line 629  createcodelet()
629  {  {
630      # create codelet for comparing model output      # create codelet for comparing model output
631    
632      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
633      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
634  #include <stdio.h>  #include <stdio.h>
635  #include <math.h>  #include <math.h>
# Line 615  int main( int argc, char** argv )  { Line 638  int main( int argc, char** argv )  {
638    double a,b,abave,relerr;    double a,b,abave,relerr;
639    best = -22;    best = -22;
640    lncnt = 0;    lncnt = 0;
641    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
642      scanf("%d", &linnum);      scanf("%d", &linnum);
643      if (linnum == -1)  break;      if (linnum == -1)  break;
644      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
# Line 659  formatresults() Line 682  formatresults()
682      nm=$1      nm=$1
683      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
684      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
685      printf '%3s' $@      listPrt=$@
686        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
687        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
688        printf '%3s' $listPrt
689    #   line below does not work on hp-ux_ia64 : do those substitutions later on
690    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
691            
692      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
693            printf ' N/O '
694        elif [ $xx = '--' ]; then
695            printf ' N/O '
696        elif [ $xx = 99 ]; then
697          printf ' N/O '          printf ' N/O '
698      else      else
699          if [ $1 -ge $MATCH_CRIT ]; then          if [ $xx -ge $MATCH_CRIT ]; then
700              printf ' pass'              printf ' pass'
701          else          else
702              printf ' FAIL'              printf ' FAIL'
# Line 679  scandirs() Line 711  scandirs()
711  {  {
712      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
713          for arg in * ; do          for arg in * ; do
714              test -d $arg/$1 && echo $arg              test -f $arg/$1 && echo $arg
715          done          done
716      else      else
717          echo $*          echo $*
# Line 694  scandirs() Line 726  scandirs()
726  debug=0  debug=0
727  verbose=1  verbose=1
728  clean=0  clean=0
 expts=''  
 # ieee=1  
729    
730  IEEE=true  IEEE=true
731  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
732      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
733  fi  fi
734    GSL=f
735    
736  CLEANUP=f  CLEANUP=f
737  QUICK=f  QUICK=f
# Line 717  TESTDIRS= Line 747  TESTDIRS=
747  SKIPDIRS=  SKIPDIRS=
748  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
749  HAVE_MPACK=  HAVE_MPACK=
750  MPACK="$MPACKDIR/mpack"  MPACK=
751  COMMAND=  COMMAND=
752  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
753      MAKE=make      MAKE=make
# Line 766  for ac_option ; do Line 796  for ac_option ; do
796              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
797          -addr=* | --addr=*)          -addr=* | --addr=*)
798              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
799            -mpackdir | --mpackdir | -mpd | --mpd)
800                ac_prev=MPACKDIR ;;
801            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
802                MPACKDIR=$ac_optarg ;;
803    
804          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
805              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
# Line 831  for ac_option ; do Line 865  for ac_option ; do
865    
866          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
867          -noieee) IEEE= ;;          -noieee) IEEE= ;;
868            -gsl) GSL=t ;;
869    
870          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
871          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 864  if test "x$QUICK" = xt ; then Line 899  if test "x$QUICK" = xt ; then
899      NODEPEND=t      NODEPEND=t
900  fi  fi
901    
902    #- setting for forward or ADM testing
903    if test "x$ADM" = xt ; then
904        code_dir=code_ad
905        inputdir=input_ad
906        ref_outp="output_adm.txt"
907        EXECUTABLE="mitgcmuv_ad"
908    else
909        code_dir=code
910        inputdir=input
911        ref_outp="output.txt"
912        EXECUTABLE="mitgcmuv"
913    fi
914    
915  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
916      if test "x$ADM" = xt ; then      LIST=`scandirs results/$ref_outp`
         LIST=`scandirs results_ad`  
     else  
         LIST=`scandirs results`  
     fi  
917  else  else
918      #- expand group of experiments:      #- expand group of experiments:
919      LIST=" "      LIST=" "
# Line 913  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 957  if test "x$OPTFILE" = xNONE -a "x$MITGCM
957      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
958  fi  fi
959    
960  if test "x$ADM" = xt ; then  OUTPUTFILE=$ref_outp
     EXECUTABLE="mitgcmuv_ad"  
     OUTPUTFILE="output_adm.txt"  
 else  
     EXECUTABLE="mitgcmuv"  
     OUTPUTFILE="output.txt"  
 fi  
   
961  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
962      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
963  fi  fi
# Line 928  if test "x$MPI" = xt ; then Line 965  if test "x$MPI" = xt ; then
965      OUTPUTFILE="STDOUT.0000"      OUTPUTFILE="STDOUT.0000"
966  fi  fi
967    
 #echo "OK"  
968  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
969    
970    # set the Default List of output variables to be checked:
971    #  (use default or load experiment-specific list from file "tr_checklist")
972    # content : 1rst = main variable used to decide if it pass or FAIL
973    #         others = number of matching digits to be printed in summary.txt
974    if test "x$ADM" = x ; then
975        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
976        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
977        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
978        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
979        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
980    else
981        DEF_CHECK_LIST='Grad Cost Grad'
982        EMPTY_RESULTS='.. ..'
983        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
984    fi
985    
986  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
987  createcodelet  createcodelet
988    
989  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
990  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
991      echo "skipping mpack build"      echo "skipping mpack build"
992  else  else
993      build_mpack      build_mpack
994  fi  fi
995    
996  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
997    CMDLINE=$0
998    for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
999  MACH=`hostname`  MACH=`hostname`
1000  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1001  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
# Line 962  if test "x$RETVAL" != x0 ; then Line 1016  if test "x$RETVAL" != x0 ; then
1016      exit 1      exit 1
1017  fi  fi
1018  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1019  start_date=`date`  start_date=`date`
1020  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1021    echo 'run:' $CMDLINE >> $SUMMARY
1022    echo 'on :' $UNAMEA  >> $SUMMARY
1023    
1024  of_path=  of_path=
1025  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 995  echo Line 1050  echo
1050  echo >> $SUMMARY  echo >> $SUMMARY
1051  if test "x$ADM" = x ; then  if test "x$ADM" = x ; then
1052      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1053      then line_0="      "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1054      else line_0="     "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
1055      line_0="   $line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1056  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1057      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1058      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
# Line 1022  if test "x$ADM" = x ; then Line 1077  if test "x$ADM" = x ; then
1077  else  else
1078      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1079      echo >> $SUMMARY      echo >> $SUMMARY
1080        if [ $MATCH_CRIT -lt 10 ] ;
1081        then line_0="default     "$MATCH_CRIT ;
1082        else line_0="default    "$MATCH_CRIT ; fi
1083        echo "$line_0" | tee -a $SUMMARY
1084      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1085  G D M    C  G  G D M    C  G
1086  E p a R  o  r  E p a R  o  r
# Line 1034  fi Line 1093  fi
1093  #  ...and each test directory...  #  ...and each test directory...
1094  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1095            
1096        # set builddir & rundir:
1097        builddir="build"
1098        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1099        rundir="run"
1100        if test ! -d $dir/$rundir ; then
1101            rundir=$builddir
1102        fi
1103        CODE_DIR=$dir/$code_dir
1104        BUILD_DIR=$dir/$builddir
1105    
1106      #  Cleanup only!      #  Cleanup only!
1107      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1108          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1109              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/build
1110              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1111          fi          fi
1112          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1113              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1114              run_clean $dir/run              run_clean $dir/$rundir
1115          fi          fi
1116          (          (
1117              cd $dir              cd $dir
# Line 1053  for dir in $TESTDIRS ; do Line 1122  for dir in $TESTDIRS ; do
1122    
1123      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1124      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1125      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output_adm.txt"  
     fi  
1126      if test ! -r $fout ; then      if test ! -r $fout ; then
1127          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1128          continue          continue
# Line 1069  for dir in $TESTDIRS ; do Line 1133  for dir in $TESTDIRS ; do
1133    
1134      # Check for additional types of monitor output      # Check for additional types of monitor output
1135    
     builddir="build"  
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
    #rundir=$builddir  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
       
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
         input_dirs='input'  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
         input_dirs='input_ad input'  
     fi  
     BUILD_DIR=$dir/$builddir  
   
1136      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1137          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1138          continue          continue
# Line 1099  for dir in $TESTDIRS ; do Line 1144  for dir in $TESTDIRS ; do
1144    
1145      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1146      extra_runs=      extra_runs=
1147      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1148          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1149          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1150          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1151              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1152              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1153              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1154                  if test "x$MULTI_THREAD" = "xt" ; then              if test "x$MULTI_THREAD" = "xt" ; then
1155                      if test -r $dir"/"$exd"/eedata.mth" ; then                  if test -r $dir"/"$exd"/eedata.mth" ; then
                         extra_runs="$extra_runs $name"  
                     #else echo $dir"/"$exd"/eedata.mth: not found"  
                     fi  
                 else  
1156                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1157                    #else echo $dir"/"$exd"/eedata.mth: not found"
1158                  fi                  fi
1159                else
1160                    extra_runs="$extra_runs $name"
1161              fi              fi
1162          done          fi
1163      fi      done
1164    
1165      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1166      echo      echo
# Line 1127  for dir in $TESTDIRS ; do Line 1171  for dir in $TESTDIRS ; do
1171      fi      fi
1172      echo      echo
1173      unset genmake makedepend make run      unset genmake makedepend make run
1174      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1175    
1176      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1177      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 1145  for dir in $TESTDIRS ; do Line 1189  for dir in $TESTDIRS ; do
1189              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1190              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1191              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1192              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1193              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1194              && results=`testoutput $dir $rundir "txt"`              && results=`testoutput_run $dir $rundir $ref_outp`
1195      fi      fi
1196            
1197      echo      echo
     if test "x$ADM" = x ; then  
1198          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1199          echo          echo
1200          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1201          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1202            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1203          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1204          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1205          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1206          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1207            if test "x$ADM" = xt ; then
1208                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1209                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1210                                    >> $CDIR"/summary.txt"
1211            fi
1212    
1213          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1214              unset run              unset run
1215              results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'              results=$EMPTY_RESULTS
1216                #  reference output file
1217                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1218              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1219              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1220              mkdir $rel_CDIR              mkdir $rel_CDIR
1221              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1222              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1223              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1224              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1225              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1226                  && results=`testoutput $dir tr_run.$ex ${ex}".txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1227              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1228              fres="$fres.$ex"              fres="$fres.$ex"
1229              echo              echo
1230              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1231              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1232                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1233              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1234              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1235              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1236              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1237                if test "x$ADM" = xt ; then
1238                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1239                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1240                                       >> $CDIR"/summary.txt"
1241                fi
1242              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1243                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1244              fi              fi
1245          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         echo "fresults='$fres'" > $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1246    
1247      #postclean $dir/$builddir      #postclean $dir/$builddir
1248      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1212  for dir in $TESTDIRS ; do Line 1255  for dir in $TESTDIRS ; do
1255  done  done
1256    
1257  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1258  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1259  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1260  date >> $SUMMARY  date >> $SUMMARY
1261    
# Line 1246  fi Line 1289  fi
1289  rm -f tr_cmpnum.c tr_cmpnum  rm -f tr_cmpnum.c tr_cmpnum
1290    
1291  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1292      cat $SUMMARY | sed 's/ -- -- -- --//g'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1293      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1294          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1295      fi      fi
1296      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1297  fi  fi
1298    
1299  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.92  
changed lines
  Added in v.1.114

  ViewVC Help
Powered by ViewVC 1.1.22